/*
             Object Oriented Programming using C++,
             Solution Manual and Applied Examples.
              written by Dr. Farschad Torabi
             K. N. Toosi University of Technology  
                     September, 2013
           
                        Chapter 23
 Code written by: Akram Gholami Pareh & Zahra Ojaghi Seyedsaran
*/

#include<math.h>
#include<fstream>
#include<iostream>
using namespace std;

//---defining the base class---

class fatigue
{
public:
  double Sut, Sy, Se, S_e, F_a ,F_m, F_min, F_max, Nf, Ka, Kb, Kc, Kd, Ke, Kf ;
  int n, NO ;
  double a, b, t, r, d, de, h, w, temp, T, rel, temp1, temp2, Kd1, Kd2, Ke1, Ke2, rel1, rel2 ;
  int m, o, p, u, i, j, AISI, T_min, T_max ;
  //---calculate the fatigue factor of safety---

  void calNf()
  {
    cout<<"\n\n please choose the fatigue failure criteria for fluctuating stress\n (1= Modified Goodman, 2=Gerber, 3=ASME_Elliptic):  ";
    cin>> n;

    switch(n)
    {
    case(1) :
      {
        Nf = 1/((F_a/Se)+(F_m/Sut)) ;
        cout<<"\n -> Nf= "<< Nf<<endl ;
        break ;
      }
    case(2) :
      {
        Nf= 0.5* (Sut/F_m)* (Sut/F_m)* (F_a/Se)* ( -1+ sqrt( 1+ ((( 2* F_m* Se)/ ( Sut* F_a))* (( 2* F_m* Se)/ ( Sut* F_a)))));
        cout<<"\n -> Nf= "<< Nf<<endl ;
        break ;
      }
    case(3) :
      {
        Nf= sqrt(1/((F_a/Se)* (F_a/Se)+(F_m/Sy)* (F_m/Sy)));
        cout<<"\n -> Nf= "<< Nf<<endl ;
        break ;
      }
    }
  }
  virtual void calSut_Sy()= 0 ;
  virtual void calF_a()= 0 ;
  virtual void calF_m() = 0 ;
  virtual void calS_e()= 0 ;
  virtual void calKa()= 0 ;
  virtual void calKb()= 0 ;
  virtual void calKc()= 0 ;
  virtual void calKd()= 0 ;
  virtual void calKe()= 0 ;
  virtual void calKf()= 0 ;
  virtual void calSe()= 0 ;
};

//---defining SI class as a child of fatigue---

class SI : public fatigue
{
public :
  //---calculate the amplitude componet---

  virtual void calF_a()
  {
    cout<<"\n please enter the minimum stress and maximum stress in MPa:  " ;
    cin>> F_min>> F_max ;
    F_a= fabs(( F_max- F_min)/ 2) ;
    cout<<"\n -> F_a= "<< F_a<<"  MPa"<<endl ;
  }
  //---calculate the midrange component---

  virtual void calF_m()
  {
    F_m= (F_max+ F_min)/2 ;
    cout<<" -> F_m= "<< F_m<<"  MPa"<<endl ;
  }
  //---calculating the Sut and Sy---

  virtual void calSut_Sy()
  {
    ifstream inputfile;
    inputfile.open("Sut_Sy table SI.txt") ;
    cout<<"\n please choose the AISI NO of steel which you use \n (1006, 1010, 1015, 1018, 1020, 1030, 1035, 1040, \n 1045, 1050, 1060, 1080, 1095):  " ;
    cin>>NO ;
    for( i= 1; i<= 13; i++)
    {
      inputfile>> AISI>> Sut>> Sy ;
      if(AISI== NO)
      {
        cout<<" -> Sut= "<< Sut<<"  MPa"<<"\n -> Sy= "<< Sy<<"  MPa"<<endl ;
        break ;
      }
    }
    inputfile.close() ;
  }
  //---calculating the S_e---

  virtual void calS_e()
  {
    if(Sut<= 1400)
    {
      S_e= 0.5* Sut ;
    }
    if(Sut> 1400)
    {
      S_e= 700 ;
    }
  }
  //---calculating Ka---

  virtual void calKa()
  {
    cout<<"\n please choose the surface finish\n (1= ground, 2= machined or cold-drown, 3= hot-rolled, 4= as-forged):  " ;
    cin>> m;

    switch(m)
    {
    case(1) :
      {
        a=1.58;
        b=-0.085;
        break ;
      }
    case(2) :
      {
        a= 4.51;
        b=-0.265;
        break ;
      }
    case(3) :
      {
        a= 57.7;
        b= -0.718;
        break ;
      }
    case(4) :
      { 
        a= 272.0;
        b= -0.995;
        break ;
      }
    }
    Ka= a* pow( Sut, b);
    cout<<"\n -> Ka= "<< Ka<<endl ;
  }
  //---calculating the Kb---

  virtual void calKb()
  {
    cout<<"\n please choose the beam motion (1= rotating, 2= nonrotating):  " ;
    cin>> u ;
    cout<<" please choose the type of load (1= axial, 2= bending, 3= torsion):  " ;
    cin>> o;
    cout<<" please choose the cross section type (1= circle, 2= rectangular):  " ;
    cin>> p ;
    switch(o)
    {
    case(1) :
      {
        Kb= 1 ;
        cout<<"\n -> Kb= "<< Kb<<endl ;
        break ;
      }
    case(2) :
      {
        if( p==1)
        {
          cout<<"\n please enter the raduis in millimeter (2.79 - 254):  " ;
          cin>> d;
        }
        if( p==1 && u==1 && 2.79<= d<= 51)
        {
          Kb= 1.24* pow( d, -0.107) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==1 && u==1 && 51< d<= 254)
        {
          Kb= 1.51* pow( d, -0.157) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==1 && u==2)
        {
          de= 0.37* d ;
        }
        if(p==1 && u==2 && 2.79<= de<= 51)
        {
          Kb= 1.24* pow( de, -0.107) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==1 && u==2 && 51< de<= 254)
        {
          Kb= 1.51* pow( de, -0.157) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==2)
        {
          cout<<"\n please enter the hight and width in millimeter:  ";
          cin>> h>> w ;
        }
        if( p==2 && u==1 )
        {
          de= 0.808* sqrt((h* w)) ;
        }
        if(p==2 && u==1 && 2.79<= de<= 51)
        {
          Kb= 1.24* pow( de, -0.107) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==2 && u==1 && 51< de<= 254)
        {
          Kb= 1.51* pow( de, -0.157) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==2 && u==2 )
        {
          de= 0.808* sqrt((h* w)) ;
        }
        if(p==2 && u==2 && 2.79<= de<= 51)
        {
          Kb= 1.24* pow( de, -0.107) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==2 && u==2 && 51< de<= 254)
        {
          Kb= 1.51* pow( de, -0.157) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        break ;
      }
    case(3) :
      {
        if( p==1)
        {
          cout<<"\n please enter the raduis in millimeter (2.79 - 254):  ";
          cin>> d;
        }
        if( p==1 && u==1 && 2.79<= d<= 51)
        {
          Kb= 1.24* pow( d, -0.107) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==1 && u==1 && 51< d<= 254)
        {
          Kb= 1.51* pow( d, -0.157) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==1 && u==2)
        {
          de= 0.37* d ;
        }
        if(p==1 && u==2 && 2.79<= de<= 51)
        {
          Kb= 1.24* pow( de, -0.107) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==1 && u==2 && 51< de<= 254)
        {
          Kb= 1.51* pow( de, -0.157) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==2)
        {
          cout<<"\n please enter the hight and width in millimeter:  ";
          cin>> h>> w ;
        }
        if( p==2 && u==1 )
        {
          de= 0.808* sqrt((h* w)) ;
        }
        if(p==2 && u==1 && 2.79<= de<= 51)
        {
          Kb= 1.24* pow( de, -0.107) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==2 && u==1 && 51< de<= 254)
        {
          Kb= 1.51* pow( de, -0.157) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==2 && u==2 )
        {
          de= 0.808* sqrt((h* w)) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if(p==2 && u==2 && 2.79<= de<= 51)
        {
          Kb= 1.24* pow( de, -0.107) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==2 && u==2 && 51< de<= 254)
        {
          Kb= 1.51* pow( de, -0.157) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        break ;
      }
    }
  }
  //---calculating the Kc---

  virtual void calKc()
  {
    switch(o)
    {
    case(1) :
      {
        Kc= 0.85;
        cout<<" -> Kc= "<< Kc<<endl ;
        break ;
      }
    case(2) :
      {
        Kc= 1;
        cout<<" -> Kc= "<< Kc<<endl ;
        break ;
      }
    case(3) :
      {
        Kc= 0.59;
        cout<<" -> Kc= "<< Kc<<endl ;
        break ;
      }
    }
  }
  //---calculating the Kd---

  virtual void calKd()
  {
    ifstream inputfile ;
    inputfile.open("temperature factor table SI.txt");
    cout<<"\n please enter the temperature that the device works (20 - 600):  " ;
    cin>> T ;
    inputfile>> temp1>> Kd1 ;
    for( i=1; i<= 12; i++)
    {
      inputfile>> temp2>> Kd2 ;
      if( T>= temp1 && T<= temp2)
      {
        Kd= Kd1+ ((( T- temp1)* ( Kd2- Kd1))/( temp2- temp1)) ;
        cout<<"\n -> Kd= "<< Kd<<endl ;
        break ;
      }
      temp1= temp2 ;
      Kd1= Kd2 ;
    }
    inputfile.close() ;
  }
  //---calculating the Ke---

  virtual void calKe()
  {
    ifstream inputfile ;
    inputfile.open("reliability factor table.txt");
    cout<<"\n please enter the reliability percent (50 - 99.9999):  " ;
    cin>> r ;
    inputfile>> rel1>> Ke1 ;
    for( i=1; i<= 7; i++)
    {
      inputfile>> rel2>> Ke2 ;
      if( r>= rel1 && r<= rel2)
      {
        Ke= Ke1+ ((( r- rel1)* ( Ke2- Ke1))/( rel2- rel1)) ;
        cout<<"\n -> Ke= "<< Ke<<endl ;
        break ;
      }
      rel1= rel2 ;
      Ke1= Ke2 ;
    }
    inputfile.close() ;
  }	
  //---calculating the Kf---

  virtual void calKf()
  {
    Kf= 1.1 ;
    cout<<" -> Kf= "<< Kf<<endl ;
  }
  //---calculate the endurance limit---

  virtual void calSe()
  {
    Se= Ka* Kb* Kc* Kd* Ke* Kf* S_e ;
    cout<<" -> Se= "<< Se<<" MPa"<<endl ;
  }
};

//---defining US class as a child of fatigue---

class US : public fatigue
{
public :
  //---calculate the amplitude componet---

  virtual void calF_a()
  {
    cout<<"\n please enter the minimum stress and maximum stress in kpsi:  " ;
    cin>> F_min>> F_max ;
    F_a= fabs(( F_max- F_min)/ 2) ;
    cout<<"\n -> F_a= "<< F_a<<"  kpsi"<<endl ;
  }
  //---calculate the midrange component---

  virtual void calF_m()
  {
    F_m= (F_max+ F_min)/2 ;
    cout<<" -> F_m= "<< F_m<<"  kpsi"<<endl ;
  }
  //---calculating the Sut_Sy---

  virtual void calSut_Sy()
  {
    ifstream inputfile;
    inputfile.open("Sut_Sy table US.txt") ;
    cout<<"\n please choose the AISI NO of steel witch you use \n (1006, 1010, 1015, 1018, 1020, 1030, 1035, 1040,\n 1045, 1050, 1060, 1080, 1095):  " ;
    cin>> NO ;
    for( i= 1; i<= 12; i++)
    {
      inputfile>> AISI>> Sut>> Sy ;
      if(AISI== NO)
      {
        cout<<" -> Sut= "<< Sut<<"  kpsi"<<"\n -> Sy= "<< Sy<<"  kpsi"<<endl ;
        break ;
      }
    }
    inputfile.close() ;
  }
  //---calculating the S_e---

  virtual void calS_e()
  {
    if(Sut<= 200)
    {
      S_e= 0.5* Sut ;
    }
    if(Sut> 200)
    {
      S_e= 100 ;
    }
  }
  //---calculating Ka---

  virtual void calKa()
  {
    cout<<"\n please choose the surface finish\n (1= ground, 2= machined or cold-drown, 3= hot-rolled, 4= as-forged):  " ;
    cin>> m;

    switch(m)
    {
    case(1) :
      {
        a=1.34;
        b=-0.085;
        break ;
      }
    case(2) :
      {
        a= 2.70;
        b=-0.265;
        break ;
      }
    case(3) :
      {
        a= 14.4;
        b= -0.718;
        break ;
      }
    case(4) :
      { 
        a= 39.9;
        b= -0.995;
        break ;
      }
    }

    Ka= a* pow( Sut, b);
    cout<<"\n -> Ka= "<< Ka<<endl ;
  }
  //---calculating the Kb---

  virtual void calKb()
  {
    cout<<"\n please choose the beam motion (1= rotating, 2= nonrotating):  " ;
    cin>> u ;
    cout<<" please choose the type of load (1= axial, 2= bending, 3= torsion):  " ;
    cin>> o;
    cout<<" please choose the cross section type (1= circle, 2= rectangular):  " ;
    cin>> p ;
    switch(o)
    {
    case(1) :
      {
        Kb= 1 ;
        cout<<"\n -> Kb= "<< Kb<<endl ;
        break ;
      }
    case(2) :
      {
        if( p==1)
        {
          cout<<"\n please enter the raduis in inch (0.11 - 10):  " ;
          cin>> d;
        }
        if( p==1 && u==1 && 0.11<= d<= 2)
        {
          Kb= 0.879* pow( d, -0.107) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==1 && u==1 && 2< d<= 10)
        {
          Kb= 0.91* pow( d, -0.157) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==1 && u==2)
        {
          de= 0.37* d ;
        }
        if(p==1 && u==12 && 0.11<= de<= 2)
        {
          Kb= 0.879* pow( de, -0.107) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==1 && u==2 && 2< de<= 10)
        {
          Kb= 0.91* pow( de, -0.157) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==2)
        {
          cout<<"\n please enter the hight and width in inch:  " ;
          cin>> h>> w ;
        }
        if( p==2 && u==1 )
        {
          de= 0.808* sqrt( h* w) ;
        }
        if(p==2 && u==1 && 0.11<= de<= 2)
        {
          Kb= 0.879* pow( de, -0.107) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==2 && u==1 && 2< de<= 10)
        {
          Kb= 0.91* pow( de, -0.157) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==2 && u==2 )
        {
          de= 0.808* sqrt( h* w) ;
        }
        if(p==2 && u==2 && 0.11<= de<= 2)
        {
          Kb= 0.879* pow( de, -0.107) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==2 && u==2 && 2< de<= 10)
        {
          Kb= 0.91* pow( de, -0.157) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        break ;
      }
    case(3) :
      {
        if( p==1)
        {
          cout<<"\n please enter the raduis in inch (0.11 - 10):  " ;
          cin>> d;
        }
        if( p==1 && u==1 && 0.11<= d<= 2)
        {
          Kb= 0.879* pow( d, -0.107) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==1 && u==1 && 2< d<= 10)
        {
          Kb= 0.91* pow( d, -0.157) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==1 && u==2)
        {
          de= 0.37* d ;
        }
        if(p==1 && u==12 && 0.11<= de<= 2)
        {
          Kb= 0.879* pow( de, -0.107) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==1 && u==2 && 2< de<= 10)
        {
          Kb= 0.91* pow( de, -0.157) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==2)
        {
          cout<<"\n please enter the hight and width in inch:  " ;
          cin>> h>> w ;
        }
        if( p==2 && u==1 )
        {
          de= 0.808* sqrt((h* w)) ;
        }
        if(p==2 && u==1 && 0.11<= de<= 2)
        {
          Kb= 0.879* pow( de, -0.107) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==2 && u==1 && 2< de<= 10)
        {
          Kb= 0.91* pow( de, -0.157) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==2 && u==2 )
        {
          de= 0.808* sqrt((h* w)) ;
        }
        if(p==2 && u==2 && 0.11<= de<= 2)
        {
          Kb= 0.879* pow( de, -0.107) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        if( p==2 && u==2 && 2< de<= 10)
        {
          Kb= 0.91* pow( de, -0.157) ;
          cout<<"\n -> Kb= "<< Kb<<endl ;
          break ;
        }
        break ;
      }
    }
  }
  //---calculating the Kc---

  virtual void calKc()
  {
    switch(o)
    {
    case(1) :
      {
        Kc= 0.85;
        cout<<" -> Kc= "<< Kc<<endl ;
        break ;
      }
    case(2) :
      {
        Kc= 1;
        cout<<" -> Kc= "<< Kc<<endl ;
        break ;
      }
    case(3) :
      {
        Kc= 0.59;
        cout<<" -> Kc= "<< Kc<<endl ;
        break ;
      }
    }
  }
  //---calculating the Kd---

  virtual void calKd()
  {
    ifstream inputfile ;
    inputfile.open("temperature factor table US.txt");
    cout<<"\n please enter the temperature that the device works (70 - 1100):  " ;
    cin>> T ;
    inputfile>> temp1>> Kd1 ;
    for( i=1; i<= 11; i++)
    {
      inputfile>> temp2>> Kd2 ;
      if( T>= temp1 && T<= temp2)
      {
        Kd= Kd1+ ((( T- temp1)* ( Kd2- Kd1))/( temp2- temp1)) ;
        cout<<"\n -> Kd= "<< Kd<<endl ;
        break ;
      }
      temp1= temp2 ;
      Kd1= Kd2 ;
    }
    inputfile.close() ;
  }

  //---calculating the Ke---

  virtual void calKe()
  {
    ifstream inputfile ;
    inputfile.open("reliability factor table.txt");
    cout<<"\n please enter the reliability percent (50 - 99.9999):  " ;
    cin>> r ;
    inputfile>> rel1>> Ke1 ;
    for( i=1; i<= 7; i++)
    {
      inputfile>> rel2>> Ke2 ;
      if( r>= rel1 && r<= rel2)
      {
        Ke= Ke1+ ((( r- rel1)* ( Ke2- Ke1))/( rel2- rel1)) ;
        cout<<"\n -> Ke= "<< Ke<<endl ;
        break ;
      }
      rel1= rel2 ;
      Ke1= Ke2 ;
    }
    inputfile.close() ;
  }
  //---calculating the Kf---
  virtual void calKf()
  {
    Kf= 1.1 ;
    cout<<" -> Kf= "<< Kf<<endl ;
  }
  //---calculate the endurance limit---

  virtual void calSe()
  {
    Se= Ka* Kb* Kc* Kd* Ke* Kf* S_e ;
    cout<<" -> Se= "<< Se<<" kpsi"<<endl ;
  }
};
//---end of class---


int main()
{
  fatigue *FF ;
  int type ;
  cout<<" please choose the system which match the dimentions (1= SI, 2= US):  ";
  cin>>type ;

  switch(type)
  {
  case(1) :
    {
      FF= new SI ;
      break ;
    }
  case(2) :
    {
      FF= new US ;
      break ;
    }
  }
  FF-> calSut_Sy() ;
  FF-> calF_a() ;
  FF-> calF_m() ;
  FF-> calS_e() ;
  FF-> calKa() ;
  FF-> calKb() ;
  FF-> calKc() ;
  FF-> calKd() ;
  FF-> calKe() ;
  FF-> calKf() ;
  FF-> calSe() ;
  FF-> calNf() ;

  return 0;
}